/*************************************************************************/

#include <errno.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define DIGITMAX       128 /* max number of input digits        */
#define TRUE            1
#define FALSE           0


int checkarray[10];               /* subscripts indicate usable digits    */
char digits[DIGITMAX];            /* the digits on the command line       */
int digitlen;                     /* how many digits were given           */
int totalfound;                   /* total number of 6 number combination */
int totalvalidfound=0;            /* number of combinations using digits  */
int numusedall=0;
long int total;
int numberwanted=6;
int maxnumber=49;
int flag_array[99+1]; /* subscripts indicate possible numbers */
int newarray[99+1];                 /* holds all possible numbers           */

/* globals for getopt */
int	optind	= 1;	/* index of which argument is next	*/
char   *optarg;		/* pointer to argument of current option */
int	opterr	= 1;	/* allow error message	*/
int	getopt(int argc, char *argv[], char *optionS);

/**************************************************************************/
/* sortstring() - sorts the given digits 0-9, uses bubble sort but that   */
/*  is the least of the speed problems.                                   */
/**************************************************************************/
void sortstring()
{
   int i, j, tmp;

   /* bubble sort, but it's only called once, so fuck it! */
   for (i=0;i<(digitlen-1);i++)
      for (j=0;j<(digitlen-1-i);j++)
	 if (digits[j] > digits[j+1]) {
	    tmp = digits[j];
	    digits[j] = digits[j+1];
	    digits[j+1] = tmp;
	 }
} /* sortstring */

/**************************************************************************/
/* findvalidnumbers() - finds all possible combinations of the given      */
/* digits that are between 1 and 49.  (1 and MAXDIGITWANTED).             */
/**************************************************************************/
void findvalidnumbers()
{
	int i,j;
	char test[3]="  \0";
	int tnum;

	/* from left to right, try each digit */
	/* with every one after it.           */
	for (i=0;i<(digitlen-1);i++)
		for(j=(i+1);j<digitlen;j++) {
			test[0] = digits[i];
			test[1] = digits[j];
			tnum = atoi(test);
			if (tnum <= maxnumber && tnum > 0)
				flag_array[tnum] = TRUE;
			}

	/* from right to left, try each digit */
	/* with every one before it.          */
	for (i=(digitlen-1);i>0;i--)
		for(j=(i-1);j;j--) {
			test[0] = digits[i];
			test[1] = digits[j];
			tnum = atoi(test);
			if (tnum <= maxnumber && tnum > 0)
				flag_array[tnum] = TRUE;
			}

	/* each digit alone is valid also */
	test[1] = '\0';
	for (i=0;i<digitlen; i++) {
	   test[0] = digits[i];
	   tnum = atoi(test);
	   flag_array[tnum] = TRUE;
	   }
	flag_array[0] = FALSE;
} /* findvalidnumbers */


/**************************************************************************/
/* printnumbers() - prints out all valid numbers less than MAXDIGITWANTED */
/**************************************************************************/
void printnumbers(int print)
{
	int i;
	totalfound = 0;

	if (print)
	   printf("\nNumbers checked: ");

	for (i=1; i < maxnumber+1; i++)
		if (flag_array[i]) {
		   if (print)
		      printf("%d ", i);
		   totalfound++;
		   }
	if (print)
	   printf("\nTotal number of numbers to check           = %d\n",totalfound);
} /* printnumbers */

/**************************************************************************/
/* makenewarray() - copies the valid numbers flagged in flag_array  to    */
/* be real numbers in newarray.                                           */
/**************************************************************************/
void makenewarray()
{
	int i,j=0;

	for (i=0;i<maxnumber+1; i++)
	   if (flag_array[i] == TRUE)
	      newarray[j++] = i;
} /* makenewarray */


/**************************************************************************/
/* makecheckarray() - builds 10 element array whose values indicate how   */
/* many of its subscripts digits are available for use.                   */
/**************************************************************************/
void makecheckarray()
{
	int i;

	for (i=0;i<10;i++)
		checkarray[i] = 0;

	for (i=0; i<digitlen; i++)
		switch (digits[i]) {
			case '0':
				checkarray[0]++;
				break;
			case '1':
				checkarray[1]++;
				break;
			case '2':
				checkarray[2]++;
				break;
			case '3':
				checkarray[3]++;
				break;
			case '4':
				checkarray[4]++;
				break;
			case '5':
				checkarray[5]++;
				break;
			case '6':
				checkarray[6]++;
				break;
			case '7':
				checkarray[7]++;
				break;
			case '8':
				checkarray[8]++;
				break;
			case '9':
				checkarray[9]++;
				break;
			}
} /* makecheckarray */


/**************************************************************************/
/* checkdigits() - checks the six numbers given to see that they do not   */
/* use any more digits that are available as indicated by the check array */
/**************************************************************************/
void checkdigits(int one, int two, int three, int four, int five, int six)
{
	char shit[3];
	int tmparray[10];
	int args[128];
	int i,j, good, realgood;

	/* copy to an array so I can loop through them */
	args[0] = one;	args[1] = two;	args[2] = three;
        args[3] = four;	args[4] = five;	args[5] = six;

	shit[2] = '\0'; /* null the end of the string */

	for (i=0;i<10;i++) /* copy the checkarray */
		tmparray[i] = checkarray[i];

	for (i=0;i<numberwanted;i++) {                     /* check each number       */
		sprintf(shit,"%d", args[i]);    /* get digits of number    */
		for (j=0;j<2;j++) {             /* check both digits, or 1 */
		   switch (shit[j]) {           /* check of used digits    */
			case '0':
			   tmparray[0]--;
			   break;
			case '1':
			   tmparray[1]--;
			   break;
			case '2':
			   tmparray[2]--;
			   break;
			case '3':
			   tmparray[3]--;
			   break;
			case '4':
			   tmparray[4]--;
			   break;
			case '5':
			   tmparray[5]--;
			   break;
			case '6':
			   tmparray[6]--;
			   break;
			case '7':
			   tmparray[7]--;
			   break;
			case '8':
			   tmparray[8]--;
			   break;
			case '9':
			   tmparray[9]--;
			   break;
			}
		   }
		}

	good = TRUE;
	realgood = TRUE;
	for (i=0;i<10;i++) {        /* see if numbers used too many digits */
	   if (tmparray[i] != 0)
	      realgood = FALSE;
	   if (tmparray[i] < 0)
	      good = FALSE;
	   }

	if (good) {               /* if not using too many, valid number  */
	   for (i=0;i<numberwanted;i++)      /* print out all 6 numbers              */
		printf("%d ", args[i]);
	   if (realgood) {
		printf("*");
		numusedall++;
	   }
	   printf("\n");
	   totalvalidfound++;     /* inc total number valid found         */
	   }
} /* checkdigits */

/**************************************************************************/
/* printall() - doesn't print, finds all possible 6 number combinations   */
/* using the numbers in newarray.                                         */
/**************************************************************************/
void printall()
{
	int i,j,k,l,m,n;
	total=0;

	if (totalfound < numberwanted+1) {
		printf("Sorry there are less than 7 numbers.");
		exit(1);
	}

	/* now you know why this thing is so slow */
	for (i=0; i< (totalfound-numberwanted+1);i++)
	   for (j=i+1; j<(totalfound-numberwanted+2);j++)
	      for (k=j+1;k<(totalfound-numberwanted+3);k++)
		 for (l=k+1;l<(totalfound-numberwanted+4);l++)
		    for (m=l+1;m<(totalfound-numberwanted+5);m++)
		       if (numberwanted == 5) {
			  checkdigits(newarray[i], newarray[j],
				      newarray[k], newarray[l],
				      newarray[m], 0);
			  total++;
			  }
		       else
		       for (n=m+1;n<(totalfound-numberwanted+6);n++) {
			  checkdigits(newarray[i], newarray[j],
				      newarray[k], newarray[l],
				      newarray[m], newarray[n]);
			  total++;
			  }

} /* printall */

/**************************************************************************/
/* main(argc, argv) - main function.                                      */
/**************************************************************************/
void main(int argc, char *argv[])
{
	int Ret;
	int seconds;
	div_t Minutes_Seconds;

	printf("SSN v 1.0 The Social Security Number -- Lottery Number Generator \n(C) 1991 Descriptive Solutions and J. Kyle McPeek\n");

	if (argc < 2) {
		printf("Usage: ssn [-m #| -n #] #########\n");
		exit(1);
		}

	do {
	   Ret = getopt(argc, argv, "M:m:n:N:");
	   switch (Ret) {
		case 'M':
		case 'm':
			maxnumber = atoi(argv[optind++]);
			if (maxnumber > 127 || maxnumber < 20) {
			   printf("ERROR: maximum number must be between 20 and 127, not %d\n",maxnumber);
			   exit(1);
			   }
			break;
		case 'n':
		case 'N':
			numberwanted = atoi(argv[optind++]);
			if (numberwanted != 5 && numberwanted != 6) {
			   printf("ERROR: number of numbers wanted must be 5 or 6, not %d\n",numberwanted);
			   exit(1);
			   }
			break;
		case '^':
			printf("ERROR: Invalid switch !\n");
			break;
		default:
			break;
		}
	   } while (Ret != EOF);

	printf("Matching %d out of %d numbers.\n", numberwanted, maxnumber);
	strncpy(digits, argv[argc-1]);
	printf("\nThe Possible numbers are:\n");
	digitlen = strlen(digits); /* get length of digits                 */
	sortstring();              /* put digits in order                  */
	findvalidnumbers();        /* find possible numbers                */
	printnumbers(FALSE);       /* print all possible numbers           */
	makenewarray();            /* store possible numbers               */
	makecheckarray();          /* make count array of digits           */
	printall();                /* find all combinations and check them */

	printnumbers(TRUE);
	printf("Total combinations found to check          = %ld\n",total);
	printf("Total combinations found using some digits = %d\n", totalvalidfound);
	printf("Total combinations found using all digits  = %d\n", numusedall);
/*	printf("\nMatching %d out of %d numbers.\n", numberwanted, maxnumber);*/

	printf("\nIf these numbers win any money for you,  you should send 1%% of \n");
	printf("such money to J. Kyle McPeek at Descriptive Solutions, P.O. Box 964,\n");
	printf("Pikeville, KY 41501.  Or your conscience will haunt you forever.\n");

	seconds = clock()/CLK_TCK;
	Minutes_Seconds = div(seconds,60);
	printf("Elapsed Time: %02d:%02d", Minutes_Seconds.quot, Minutes_Seconds.rem);
} /* main */

/*
	getopt.c -- Turbo C

	Copyright (c) 1986,87,88 by Borland International Inc.
	All Rights Reserved.
*/

static	char   *letP = NULL;	/* remember next option char's location */
static	char	SW = '-';	/* Screw DOS. Switch character '-' NOT  '/' */

/*
  Parse the command line options, System V style.

  Standard option syntax is:

    option ::= SW [optLetter]* [argLetter space* argument]

  where
    - SW is either '/' or '-', according to the current setting
      of the MSDOS switchar (int 21h function 37h).
    - there is no space before any optLetter or argLetter.
    - opt/arg letters are alphabetic, not punctuation characters.
    - optLetters, if present, must be matched in optionS.
    - argLetters, if present, are found in optionS followed by ':'.
    - argument is any white-space delimited string.  Note that it
      can include the SW character.
    - upper and lower case letters are distinct.

  There may be multiple option clusters on a command line, each
  beginning with a SW, but all must appear before any non-option
  arguments (arguments not introduced by SW).  Opt/arg letters may
  be repeated: it is up to the caller to decide if that is an error.

  The character SW appearing alone as the last argument is an error.
  The lead-in sequence SWSW ("--" or "//") causes itself and all the
  rest of the line to be ignored (allowing non-options which begin
  with the switch char).

  The string *optionS allows valid opt/arg letters to be recognized.
  argLetters are followed with ':'.  Getopt () returns the value of
  the option character found, or EOF if no more options are in the
  command line.	 If option is an argLetter then the global optarg is
  set to point to the argument string (having skipped any white-space).

  The global optind is initially 1 and is always left as the index
  of the next argument of argv[] which getopt has not taken.  Note
  that if "--" or "//" are used then optind is stepped to the next
  argument before getopt() returns EOF.

  If an error occurs, that is an SW char precedes an unknown letter,
  then getopt() will return a '?' character and normally prints an
  error message via perror().  If the global variable opterr is set
  to false (zero) before calling getopt() then the error message is
  not printed.

  For example, if the MSDOS switch char is '/' (the MSDOS norm) and

    *optionS == "A:F:PuU:wXZ:"

  then 'P', 'u', 'w', and 'X' are option letters and 'F', 'U', 'Z'
  are followed by arguments.  A valid command line may be:

    aCommand  /uPFPi /X /A L someFile

  where:
    - 'u' and 'P' will be returned as isolated option letters.
    - 'F' will return with "Pi" as its argument string.
    - 'X' is an isolated option.
    - 'A' will return with "L" as its argument.
    - "someFile" is not an option, and terminates getOpt.  The
      caller may collect remaining arguments using argv pointers.
*/

int	getopt(int argc, char *argv[], char *optionS)
{
	unsigned char ch;
	char *optP;

	if (SW == 0) {
		/* get SW using dos call 0x37 */
		_AX = 0x3700;
		geninterrupt(0x21);
		SW = _DL;
	}

	if (argc > optind) {
		if (letP == NULL) {
			if ((letP = argv[optind]) == NULL ||
				*(letP++) != SW)  goto gopEOF;
			if (*letP == SW) {
				optind++;  goto gopEOF;
			}
		}
		if (0 == (ch = *(letP++))) {
			optind++;  goto gopEOF;
		}
		if (':' == ch  ||  (optP = (char *)strchr(optionS, ch)) == NULL)
			goto gopError;
		if (':' == *(++optP)) {
			optind++;
			if (0 == *letP) {
				if (argc <= optind)  goto  gopError;
				letP = argv[optind++];
			}
			optarg = letP;
			letP = NULL;
		} else {
			if (0 == *letP) {
				optind++;
				letP = NULL;
			}
			optarg = NULL;
		}
		return ch;
	}
gopEOF:
	optarg = letP = NULL;
	return EOF;

gopError:
	optarg = NULL;
	errno  = EINVAL;
/*	if (opterr)
		perror ("get command line option");*/
	return ('^'); /* changed from ? because I want it as help */
}
